Subject: Re: Reproducible, corrupt packfile after fresh git-svn checkout

From: Stefan Beller <[email-masked]>
Date: Thu, 08 Aug 2013 14:41:41 +0200

On 08/08/2013 02:23 PM, [email-masked] wrote:
>> Regardless of any possible fault in git-svn, there's an obvious bug here
>> with git-fsck.  Can you share the pack (if the project is public) or
>> compile a git-fsck without optimization and with debugging, and run it
>> under valgrind, to hopefully get us a backtrace of where the memory
>> management goes off the rails?
> 
> Unfortunately I'm unable to share the pack.
> 
> As Java Developer I'm note very savy, but I'd try.
> Do you have me any pointers on ".. without optimization and with
> debugging" and "run it under valgrind"?
> 
> Currently I used
>    deb http://ppa.launchpad.net/git-core/ppa/ubuntu quantal main
> as source.

The version from the ppa seems to be 1.7.0.4-1ubuntu0.2 but the version
of git being in the native ubuntu quantal repository 
(I assume you're running Ubuntu?) is already 1.7.10.4-1ubuntu1 
(http://packages.ubuntu.com/quantal/git)

However to get an unoptimized version with debug symbols you could do this:

	# get the source:
	git clone git://git.kernel.org/pub/scm/git/git.git/
	cd git

	# read INSTALL, the section starting at 
	# > Git is reasonably self-sufficient, but does depend on a few external
	# > programs and libraries
	# this is a guess, maybe you need more or less packages, but you'd need the -dev packages for the C-headers
	sudo apt-get install libz-dev libopenssl-dev libcurl-dev libexpat-dev 
	
	# Now disable optimizing by overwriting default compile flags:
	echo "CFLAGS=-g" > config.mak

	# compile and install	
	make 
	make install # installs to ~/bin

	# open a new shell or relogin, and see if you're using the version you just build:
	git --version
	# git version 1.8.4.rc1....

Stefan